﻿using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.XmlSerializersCreator;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.XlsIO;
using Syncfusion.GroupingGridExcelConverter;
namespace WindowsFormsApplication6
{
    public partial class Form1 : Form
    {

        IWorkbook workbook;
        GridGroupingExcelConverterControl gridGroupingExcelConverter;
        List<string> controlCellsList;

        public Form1()
        {
            InitializeComponent();

            DataSet ds = new DataSet();
            ReadXml(ds, @"Expand.xml");

            ds.Relations.Add(
                ds.Tables[0].Columns["CategoryID"],
                ds.Tables[1].Columns["CategoryID"]);
            ds.Relations[0].RelationName = "Category_Products";

            this.gridGroupingControl1.DataSource = ds.Tables[0];

            this.gridGroupingControl1.TableDescriptor.Columns["Date"].Appearance.AnyRecordFieldCell.CellType = GridCellTypeName.MonthCalendar;
            GridTableDescriptor child_tabledescriptor = this.gridGroupingControl1.TableDescriptor.Relations[0].ChildTableDescriptor;
            child_tabledescriptor.Columns[2].Width = 200;
            //this.gridGroupingControl1.Table.ExpandAllRecords();
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.Style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record)
            {
                Record record = e.Style.TableCellIdentity.DisplayElement.GetRecord();
                
                //To check the child table records.
                if (record != null && record.ParentTable.FilteredChildTable != null && record.Kind == DisplayElementKind.Record)
                {
                    //Gets the parent record.
                    Record parentRecord = record.ParentChildTable.ParentNestedTable.ParentRecord;

                    //Set the celltype for child table column based on parent record.
                    if (parentRecord.GetValue("CategoryName").ToString() == "Beverages" || parentRecord.GetValue("CategoryName").ToString().Equals("Produce") || parentRecord.GetValue("CategoryName").ToString().Equals("Grains/Cereals")
                        || parentRecord.GetValue("CategoryName").ToString().Equals("Dairy Products") || parentRecord.GetValue("CategoryName").ToString().Equals("Confections"))
                    {
                        if (e.TableCellIdentity.Column != null && e.TableCellIdentity.Column.Name == "SupplierID" && int.Parse(e.Style.Text) < 15)
                        {
                            e.Style.CellType = GridCellTypeName.CheckBox;
                            e.Style.Text = "CustomText";
                        }
                    }
                }
            }
        }
        void ReadXml(DataSet ds, string xmlFileName)
        {
            for (int n = 0; n < 10; n++)
            {
                if (File.Exists(xmlFileName))
                {
                    ds.ReadXml(xmlFileName);
                    break;
                }
                xmlFileName = @"..\..\Data\" + xmlFileName;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Files(*.xls)|*.xls";

            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                ExportToExcel(saveFileDialog.FileName);
            }
            this.gridGroupingControl1.Invalidate();
            this.gridGroupingControl1.Refresh();
        }

        private void ExportToExcel(string xlsfilename)
        {
            // Creating new Excel Workbook
           workbook = ExcelUtils.CreateWorkbook(new string[] { "My Data"});
           gridGroupingExcelConverter = new GridGroupingExcelConverterControl();
           controlCellsList = new List<string>();

           // Setting the exporting options for Grid Grouping Excel converter 
           gridGroupingExcelConverter.ExportStyle = true;
           gridGroupingExcelConverter.AllowNestedTableOutling = true;
           gridGroupingExcelConverter.EnableOptimization = false;
           gridGroupingExcelConverter.ExportNestedTableCaption = true;

           // Subscribe the GridGroupingExcelConverter events for customize the exporting functionalities.
           gridGroupingExcelConverter.QueryExportNestedTable += new GridGroupingExcelConverterControl.ExportNestedTableEventHandler(gridGroupingExcelConverter_QueryExportNestedTable);
           gridGroupingExcelConverter.QueryExportCellRange += new GridGroupingExcelConverterControl.QueryExportCellRangeEventHandler(gridGroupingExcelConverter_QueryExportCellRange);
           gridGroupingExcelConverter.QueryExportRowRange += new GridGroupingExcelConverterControl.QueryExportRowRangeEventHandler(gridGroupingExcelConverter_QueryExportRowRange);

           ExcelExportingOptions options = new ExcelExportingOptions();
           // Exporting the Grouping Grid to Excel format
           gridGroupingExcelConverter.ExportToExcel(gridGroupingControl1, workbook.Worksheets["My Data"], options);

           workbook.SaveAs(xlsfilename);
           MessageBox.Show("Export completed");
        }

        void gridGroupingExcelConverter_QueryExportRowRange(object sender, Syncfusion.GroupingGridExcelConverter.QueryExportRowRangeEventArgs e)
        {
            
        }

        void gridGroupingExcelConverter_QueryExportCellRange(object sender, Syncfusion.GroupingGridExcelConverter.QueryExportCellRangeEventArgs e)
        {
            if (e.GridCell.CellType == "Control")
            {
                controlCellsList.Add("Column : " + e.GridCell.CellIdentity.ColIndex + " Row : " + e.GridCell.CellIdentity.RowIndex); 
            }
        }

        void gridGroupingExcelConverter_QueryExportNestedTable(object sender, Syncfusion.GroupingGridExcelConverter.ExportNestedTableEventArgs e)
        {
            
        }
    }
}
